import sys
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"graphviz.pmh",
				"GraphDot",
				"graphvizDL" ]

	dll = module.DLL( "fexGraphVizDL", srcList )

	dll.linkmap = { "gfxlibs": forge.gfxlibs }

	if forge.fe_os == "FE_LINUX":
		dll.linkmap["imagelibs"] = "-lgvc"
	elif forge.fe_os == "FE_WIN32" or forge.fe_os == "FE_WIN64":
		dll.linkmap["imagelibs"] = "???"

	deplibs = forge.basiclibs + [
				"fePluginLib" ]

	forge.deps( ["fexGraphVizDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"fexGraphVizDL",			None,		None) ]

def auto(module):
	test_file = """
#include <graphviz/gvc.h>

int main(void)
{
	return(0);
}
    \n"""

	gvmap = { "gfxlibs": forge.gfxlibs }
	if forge.fe_os == "FE_LINUX":
		gvmap["imagelibs"] = "-lgvc"
	elif forge.fe_os == "FE_WIN32" or forge.fe_os == "FE_WIN64":
		gvmap["imagelibs"] = "???"

	return forge.cctest(test_file, gvmap)
