/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __grass_DodgeOp_h__
#define __grass_DodgeOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator to move curves away from a collider

	@ingroup grass
*//***************************************************************************/
class FE_DL_EXPORT DodgeOp:
	public OperatorThreaded,
	public Initialize<DodgeOp>,
	public ObjectSafe<DodgeOp>
{
	public:

					DodgeOp(void):
						m_frame(-1),
						m_currentHistory(0),
						m_validCurrent(FALSE),
						m_validPrevious(FALSE)								{}

virtual				~DodgeOp(void)											{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

virtual	void		run(I32 a_id,sp<SurfaceRange> a_spRange);

	private:
		sp<SurfaceAccessibleI>		m_spOutputAccessible;
		sp<DrawMode>				m_spDebugGroup;
		sp<DrawI>					m_spDrawDebug;

		I32							m_frame;

		std::vector<SpatialVector>	m_history[2];
		I32							m_currentHistory;
		BWORD						m_validCurrent;
		BWORD						m_validPrevious;
};

} /* namespace */

#endif /* __grass_DodgeOp_h__ */

